c
c filter to reformat NCSN summary data into CNSS unified format
c
	implicit none
	real		amag1
	real		amag2
	character*2	auxrmk
	integer		az_2_err
	integer		az_3_err
	integer		azgap
	character*1	cm1
	character*1	cm2
        character*8     date
	real		depth
	real		dmin
	integer		dp_2_err
	integer		dp_3_err
	character*1	east
	real		emag(4)
	real		errh
	real		errz
	integer		eventid
	real		fmag
	character*1	fmagtype
	integer		i
        integer         id(3)
	integer		iday
	integer		ihour
	integer		imin
	integer		imonth
	integer		iunit
	integer		iyear
	real		latdeg
	real		latd
	real		latmin
	character*3	locrmk
	character*2	loctyp
	real		londeg
	real		lond
	real		lonmin
	real		madamp
	real		maddur
	character*1	magpref
	character*2	magtype(4)
	real		mg_1_err
	real		mg_2_err
	real		mg_3_err
	character*3	model
	character*1	modtype
	character*1	most_amp
	character*1	most_dur
	character*1	most_p
	integer		npfm
	integer		nps_all
	integer		nps_sol
	integer		ns
	integer		ounit
	real		pmag(4)
	real		rms
	real		sec
	character*1	south
	character*3	src
	real		sumampwt
	real		sumcm1wt
	real		sumcm2wt
	real		sumdurwt
	real		summagwt(4)
	real		sumzmagwt
	real		xmag
	character*1	xmagtype
	real		zmag
	character*1	zmagtype
	integer		iline
	integer		ios
c
	data magtype /'l1', 'c ', 'a ', 'z '/ 
	parameter (iunit = 5, ounit = 6)
c
        call idate(id)
        write (date, '(i4, 2i2.2)'), id(3), id(2), id(1)
	loctyp = 'H '

c	Network code
	src = 'NC'
c
	write (ounit, '(a)') '$fmt cnss-catalog-ver-1.0'
c
	iline =0
10	iline = iline + 1
	  do 20 i = 1, 4
	    pmag(i) = 0.
	    emag(i) = 0.
20	  continue
          read (iunit, 100, iostat = ios, end = 1000) 
	9         iyear, imonth, iday, ihour, imin, sec,
	1         latdeg, south, latmin, londeg, east,
	2         lonmin, depth, xmag, nps_sol, azgap,
	3         dmin, rms, az_3_err, dp_3_err, mg_1_err,
	4         az_2_err, dp_2_err, mg_2_err, fmag, locrmk,
	5         mg_3_err, auxrmk, ns, errh, errz,
	6         npfm, sumampwt, sumdurwt, madamp, maddur,
	7         model, modtype, most_p, most_dur, most_amp,
	8         fmagtype, nps_all, xmagtype, cm1, amag1,
	9         sumcm1wt, cm2, amag2, sumcm2wt, eventid,
	1         zmagtype, zmag, sumzmagwt
100       format (5i2, f4.2,
	1        f2.0, a1, f4.2, f3.0, a1,
	2        f4.2, f5.2, f2.1, i3, i3,
	3        f3.0, f4.2, i3, i2, f4.2,
	4        i3, i2, f4.2, f2.1, a3,
	5        f4.2, a2, i2, f4.2, f4.2,
	6        i2, f3.1, f3.1, f3.2, f3.2,
	7        a3, a1, a1, a1, a1,
	8        a1, i3, a1, a1, f3.2,
	9        f3.1, a1, f3.2, f3.1, i10,
	1        t146, a1, f3.2, f3.1)
	if (ios .ne. 0) then
	  print *, 'error on line ', iline
	  stop
	endif
	iyear = iyear + 1900
	if (south .eq. 'S' .or. south .eq. 's') latdeg = -latdeg
	if (east .eq. 'W' .or. east .eq. ' ' .or. east .eq. 'w') 
	1   londeg = -londeg
	lond = sign(abs(londeg) + abs(lonmin)/60., londeg)
	latd = sign(abs(latdeg) + abs(latmin)/60., latdeg)
c
c paste in an "L" for local earthquake if not something else. Ok to overwrite '*' and '-'
c
	if (auxrmk(1:1) .eq. 'Q' .or. auxrmk(2:2) .eq. 'Q') then
	  auxrmk(1:2) = 'Q '
	elseif (auxrmk(1:1) .eq. 'B' .or. auxrmk(2:2) .eq. 'B') then
	  auxrmk(1:2) = 'B '
	elseif (auxrmk(1:1) .eq. 'N' .or. auxrmk(2:2) .eq. 'N') then
	  auxrmk(1:2) = 'N '
	elseif (auxrmk(1:1) .eq. 'R' .or. auxrmk(2:2) .eq. 'R') then
	  auxrmk(1:2) = 'R '
	else
	  auxrmk(1:2) = 'L '
	endif
c
c
c write out $beg line
c
        write (ounit, '(a4)') '$beg'
c
c write out $loc line
c
	write (ounit, 200) iyear, imonth, iday, ihour, imin, sec,
	1 latd, lond, depth, loctyp, src, nps_sol, azgap, dmin, rms,
	2 errh, errz, auxrmk, date
200	format ('$loc ', i4, 4i2.2, f7.4,
	1 f9.5, f10.5, f8.4, a2, a3, i4, i3, f10.4, f7.4,
	2 t88, 2f7.4, a2, a8)
c
c write out $add line
c
	write (ounit, 300) nps_all, ns, npfm, az_3_err, dp_3_err,
	1                    mg_3_err, az_2_err, dp_2_err, mg_2_err,
	2                    mg_1_err, eventid
300     format ('$add$loc', 3i4, i3, i2, 
	1                    f10.4, i3, i2, f10.4,
	2                    t56, f10.4, t86, i12)
c
c Fill array of magnitudes. ML=1, coda=2, xmag=3, Zmag=4.  Ignore Menlo Recomputed ML
c No info on number or error of ML, and no error info on Zmag
c
	if (cm1.eq.'B') then
	  pmag(1)=amag1
	  summagwt(1)=sumcm1wt
	  emag(1)=0.
	elseif (cm2.eq.'B') then
	  pmag(1)=amag2
	  summagwt(1)=sumcm2wt
	  emag(1)=0.
	endif
	pmag(2)=fmag
	summagwt(2)=sumdurwt
	emag(2)=maddur
	pmag(3)=xmag
	summagwt(3)=sumampwt
	emag(3)=madamp
	pmag(4)=zmag
	summagwt(4)=sumzmagwt
	emag(4)=0.
c
c output $mag line. Only output info if mag is not zero
c Don't output value for emag, # of readings if unknown
c
	magpref = 'P'
	do i=1,4
	  if (pmag(i) .gt. 0.) then
            if (i .eq. 1) then
	      write (ounit, 400) magpref, pmag(i), magtype(i), src,
	1                          date 
400	    format ('$mag', a1, f5.2, a2, a3, 13x, a8)
	    elseif (i .eq. 2 .or. i .eq. 3) then
	      write (ounit, 410) magpref, pmag(i), magtype(i), src, 
	1                emag(i), summagwt(i), date
410	      format ('$mag', a1, f5.2, a2, a3, 4x, f5.2, f4.1, a8)
            elseif (i .eq. 4) then
	      write (ounit, 420) magpref, pmag(i), magtype(i), src, 
	1                summagwt(i), date
420	      format ('$mag', a1, f5.2, a2, a3, 4x, 5x, f4.1, a8)
	    endif
	    if (magpref .eq. 'P') magpref = ' '
	  endif
	end do
c
c write out $end line
c
	write (ounit, '(a)') '$end'
	goto 10
1000	continue
	close (2)
	close (ounit)
	end
